> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/changelogs/version-2/v2-2-2.md).

# Version 2.2.2 Changelog (2017-02-08)

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

### PDFNetJS Updates

* Added an option to use the PNaCl subzero compiler for fast worker loading
* Added functions to get/set the resource and worker paths
* Added support for custom headers
* Added digital signature support in the full build
* Fixed issues with downloader and externally imported annotations
* Fixed a timing issue where pages could be shown with the incorrect size when downloader was enabled
* Fixed issue with stamp quality loss when saving and reloading a document
* Fixed issue with incorrect stamp annotation scaling
* Fixed issue where annotations wouldn't be removed from notes panel when removing a page
* Fixed issue where page move operations were not working
* Fixed issue with password protected files when downloader is enabled
* Fixed issue when importing a large amount of XFDF data and Emscripten is being used

### WebViewer HTML5 Updates

* Added a function to disable the execution of embedded JavaScript
* Added a function to control the usable width of a text input when "scroll long text" is disabled
* Added the addField function on FieldManager allowing you to programmatically add fields
* Improved display of "comb" text fields
* Improved handling of text modifications in form fields so that they can be changed through spellcheck or suggested words
* Added support for "userName" attribute of a field when it's set dynamically
* Improved the implementation of app.alert in embedded JavaScript to handle yes/no and ok/cancel dialogs
* Updated offline mode so that encrypted documents have their parts stored encrypted in the offline database
* Fixed issue where sticky note annotations were not always being displayed upright relative to the viewer
* Fixed issue where the last letter typed would be removed from a field if there was a keystroke action that set the focus on another field
* Fixed issue with handling dates from different timezones in XFDF
* Fixed issue with field values not being loaded in some cases
* Fixed issue where calls to setFocus on a field could cause issues with field blur events
* Fixed issue with the incorrect form submit action format being used in some cases
* Fixed issue with exporting callout annotations to XFDF
* Fixed issue where a polygon wouldn't be shown as a cloud if only the "style=cloudy" property was set in the XFDF
* Fixed issue where the start and end styles of a polyline would be lost when exporting XFDF
* Fixed issue where the default signature would be added in the wrong orientation in some situations
* Fixed timing issue where CoreControls might not be defined in the WebViewer iframe yet when accessing from WebViewer.js
* Requests with HttpPartRetriever are now retried once when they fail which works around an issue in Chrome when cache hinting is disabled
* If "scroll long text" is disabled then always allow removing text even if the size of the text is over the limit
* Fixed issue with the max length setting on fields not properly being respected
* Fixed issue with error handling in StreamingPartRetriever
* Fixed issue with cursor not changing to a pointer when hovering over checkboxes in IE

### WebViewer Mobile Updates

* Fixed issue with double tap to zoom in IE and Edge


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/web/changelogs/version-2/v2-2-2.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
